#include <bits/stdc++.h>
using namespace std;

const int CISTY = 0, SPINAVY = 1, AKTUALNY = 2;
const int HLBKA = 19;

struct vrchol { 
    int zaciatok, koniec, najviac, stav; 
    void zapln(int level, int s) { stav=s; zaciatok = koniec = najviac = (s==CISTY ? (1<<level) : 0); }
};

vector< vector<vrchol> > T;

void prepocitaj_vrchol(int level, int offset) {
    if (level == 0) return;
    vrchol &ja = T[level][offset], lsyn = T[level-1][2*offset], psyn = T[level-1][2*offset+1];
    ja.stav = AKTUALNY;
    ja.zaciatok = lsyn.zaciatok;
    if (ja.zaciatok == 1 << (level-1)) ja.zaciatok += psyn.zaciatok;
    ja.koniec = psyn.koniec;
    if (ja.koniec == 1 << (level-1)) ja.koniec += lsyn.koniec;
    ja.najviac = max( max(lsyn.najviac, psyn.najviac), lsyn.koniec+psyn.zaciatok );
}

void preposli_dole(int level, int offset) {
    if (level == 0) return;
    vrchol &ja = T[level][offset], &lsyn = T[level-1][2*offset], &psyn = T[level-1][2*offset+1];
    if (ja.stav == AKTUALNY) return;
    lsyn.zapln(level-1,ja.stav);
    psyn.zapln(level-1,ja.stav);
    prepocitaj_vrchol(level,offset);
}

int najdi_prvy_usek(int dlzka, int level=HLBKA, int offset=0) {
    preposli_dole(level,offset);
    if (T[level][offset].najviac < dlzka) return -1;
    if (level == 0) return offset;
    int tmp = najdi_prvy_usek(dlzka,level-1,2*offset);
    if (tmp != -1) return tmp;
    vrchol lsyn = T[level-1][2*offset], psyn = T[level-1][2*offset+1];
    if (lsyn.koniec + psyn.zaciatok >= dlzka) return (1<<(level-1))*(2*offset+1) - lsyn.koniec;
    return najdi_prvy_usek(dlzka,level-1,2*offset+1);
}

void zaznac_usek(int lo, int hi, int stav, int level=HLBKA, int offset=0, int vlo=0, int vhi=1<<HLBKA) {
    preposli_dole(level,offset);
    if (hi <= vlo || vhi <= lo) return;
    if (lo <= vlo && vhi <= hi) { T[level][offset].zapln(level,stav); return; }
    zaznac_usek(lo,hi,stav,level-1,2*offset,vlo,(vlo+vhi)/2);
    zaznac_usek(lo,hi,stav,level-1,2*offset+1,(vlo+vhi)/2,vhi);
    prepocitaj_vrchol(level,offset);
}

int main() {
    int P, U;
    cin >> P >> U;

    T.resize(HLBKA+1);
    T[0].resize( 1<<HLBKA, {0,0,0,AKTUALNY} );
    for (int p=1; p<=P; ++p) T[0][p] = {1,1,1,AKTUALNY};
    for (int h=0; h<=HLBKA; ++h) {
        T[h].resize( 1<<(HLBKA-h) );
        for (int o=0; o<(1<<(HLBKA-h)); ++o) prepocitaj_vrchol(h,o);
    }

    while (U--) {
        string cmd; cin >> cmd;
        if (cmd == "U") {
            int d; cin >> d;
            int ans = najdi_prvy_usek(d);
            cout << ans << "\n";
            if (ans != -1) zaznac_usek(ans,ans+d,SPINAVY);
        } else {
            int x, y; cin >> x >> y;
            zaznac_usek(x,y+1,CISTY);
        }
    }
}
